# coding: utf-8

"""
    Moneyball

    Provides company-focused insights based on Live Data

    The version of the OpenAPI document: 1.0.0
    Contact: support@livedatatechnologies.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from ldt_moneyball_client_staging.models.company import Company
from typing import Optional, Set
from typing_extensions import Self

class FindCompany200Response(BaseModel):
    """
    FindCompany200Response
    """ # noqa: E501
    count: Optional[StrictInt] = Field(default=None, description="Number of companies that matched the filter criteria")
    companies: Optional[List[Company]] = None
    company_groups: Optional[List[Company]] = None
    __properties: ClassVar[List[str]] = ["count", "companies", "company_groups"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FindCompany200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in companies (list)
        _items = []
        if self.companies:
            for _item_companies in self.companies:
                if _item_companies:
                    _items.append(_item_companies.to_dict())
            _dict['companies'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in company_groups (list)
        _items = []
        if self.company_groups:
            for _item_company_groups in self.company_groups:
                if _item_company_groups:
                    _items.append(_item_company_groups.to_dict())
            _dict['company_groups'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FindCompany200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "count": obj.get("count"),
            "companies": [Company.from_dict(_item) for _item in obj["companies"]] if obj.get("companies") is not None else None,
            "company_groups": [Company.from_dict(_item) for _item in obj["company_groups"]] if obj.get("company_groups") is not None else None
        })
        return _obj


